/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Electric class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>

#include "EntityContainer.h"
#include "StarFighter.h"


#ifndef ELECTRIC_H
#define ELECTRIC_H

//------------------------------------------------------------------------------
//	Electric Enemy
//------------------------------------------------------------------------------
class Electric 
{

public:
	friend class ElectricContainer;
	
	Electric();
	~Electric();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	int		Frame;
	int 	Counter;
	bool	Active;

};

//------------------------------------------------------------------------------
//	Electric Container
//------------------------------------------------------------------------------
class ElectricContainer : public EntityContainer
{	

public:

	ElectricContainer();
    ~ElectricContainer();
    void Init( int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	void Spawn( int _x, int _y );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Electric> Electrics;
	
	
};


#endif // ELECTRIC_H
